#ifndef __TINY__
#error Must be compiled in tiny model
#endif

#define NULL 0
#if __STDC__
#define _Cdecl
#else
#define _Cdecl cdecl
#endif

void _Cdecl __int__(int interruptnum);
void __emit__();
/* extern unsigned _Cdecl _psp; */

#define _toupper(c)     ((c)&0xDF)

#define putchar(c) (_DL=c,_AH=02,__int__(0x21))

#define putbackslash() (_DL='\\',_AH=02,__int__(0x21))

void putstring(char *p)
{   unsigned int i=0;
    if (p!=NULL)
       while (p[i]!=0) putchar(p[i++]);
}

int ResetDrives(void)
{
  _AH=0;
  _DL=0x80;
  __int__(0x13);
  __emit__(0x73,0x02,0xB4,0x00);
    /* JNC L1 - MOV AH,0 - L1:         */
    /* IF CY THEN _AH=ERROR ELSE _AH=0 */
  return _AH;
}

int _WriteRootSector(unsigned int BuffOfs)
{
  _ES=_DS;
  _BX=BuffOfs;
  _AX=0x301; /* _AL=1; */
  _DX=0x80;
  _CX=1;
  __int__(0x13);
  __emit__(0x73,0x02,0xB4,0x00);
    /* JNC L1 - MOV AH,0 - L1:         */
    /* IF CY THEN _AH=ERROR ELSE _AH=0 */
  return _AH;
}

int _VerifyRootSector(unsigned int BuffOfs)
{
  _ES=_DS;
  _BX=BuffOfs;
  _AX=0x401; /* _AL=1; */
  _DX=0x80;
  _CX=1;
  __int__(0x13);
  __emit__(0x73,0x02,0xB4,0x00);
    /* JNC L1 - MOV AH,0 - L1:         */
    /* IF CY THEN _AH=ERROR ELSE _AH=0 */
  return _AH;
}

int WriteRootSector(unsigned int BuffOfs)
{
  int i,done,Err;
  for (i=done=0; i<3; i++) {
     if((Err=_WriteRootSector(BuffOfs))==0) { done=1; break; }
     ResetDrives();
  }
  if(done==0) return Err;
  else return _VerifyRootSector(BuffOfs);
}

char *UnableToWrite="\7\7Unable to write root sector\r\n";

unsigned char RootSector[512];

int cdecl main() {
/*
unsigned int DS=((unsigned long)((char far *)(&CmdStr)))>>16;
if(DS==_psp) { */
   int i;
   for (i=0; i<512; RootSector[i++]=0);
   ResetDrives();
   if(WriteRootSector((unsigned int) (RootSector)))
      putstring(UnableToWrite);
}